/****************************************************************************
File:    GLOBAL.H
Project: RocketPort System to Serial Controller Interface
Company: Comtrol Corporation
Author:  Craig Harrison
*******************************************************************************
Copyright 1993 Comtrol Corporation. All rights reserved.
This source code is Comtrol proprietary and may not be distributed outside
of Comtrol Corporation.
******************************************************************************/

#ifndef GLOBALDEFINED
#define GLOBALDEFINED


/* Master copy of AIOP microcode  */
unsigned char MasterMCode1[MCODE1_SIZE] =
{
/* indl  indh  dlo   dhi */
   0x00, 0x09, 0xF6, 0x82,
   0x02, 0x09, 0x93, 0x8C,
   0x04, 0x09, 0x86, 0x01,
   0x06, 0x09, 0x40, 0x11,
   0x08, 0x09, 0x09, 0x0A,
   0x0a, 0x09, 0x00, 0x40,
   0x0c, 0x09, 0x13, 0x09,
   0x0e, 0x09, 0x0A, 0xFA,
   0x10, 0x09, 0x83, 0x01,
   0x12, 0x09, 0x0A, 0x00,
   0x14, 0x09, 0x0A, 0xF2,
   0x16, 0x09, 0x81, 0x8A,
   0x18, 0x09, 0x13, 0xC5,
   0x1a, 0x09, 0x11, 0x86,
   0x1c, 0x09, 0x85, 0x20,
   0x1e, 0x09, 0xB8, 0x21,
   0x20, 0x09, 0xB6, 0x41,
   0x22, 0x09, 0xFF, 0x82,
   0x24, 0x09, 0x7B, 0x8A,
   0x26, 0x09, 0x7D, 0x88,
   0x28, 0x09, 0x81, 0x86,
   0x2a, 0x09, 0x7A, 0x84,
   0x2c, 0x09, 0x81, 0x82,
   0x2e, 0x09, 0x7A, 0xA7,
   0x30, 0x09, 0x82, 0xA6,
   0x32, 0x09, 0xA3, 0xCC,
   0x34, 0x09, 0x1B, 0x82,
   0x36, 0x09, 0x08, 0x82,
   0x38, 0x09, 0x15, 0xDC,
   0x3a, 0x09, 0x04, 0x82,
   0x3c, 0x09, 0x30, 0x98,
   0x3e, 0x09, 0x0A, 0x96,
   0x40, 0x09, 0x31, 0x94,
   0x42, 0x09, 0x40, 0x08,
   0x44, 0x09, 0x09, 0x40,
   0x46, 0x09, 0x20, 0x09,
   0x48, 0x09, 0x40, 0x08,
   0x4a, 0x09, 0x09, 0x8B,
   0x4c, 0x09, 0x40, 0x15,
   0x4e, 0x09, 0x09, 0x40,
   0x50, 0x09, 0x0A, 0x09,
   0x52, 0x09, 0x84, 0x09,
   0x54, 0x09, 0x82, 0x81,
   0x56, 0x09, 0x0A, 0x40,
   0x58, 0x09, 0x00, 0x08,
   0x5A, 0x09, 0x0A, 0x00
};

/* Controller structures */
#ifdef INT14DRV
CONTROLLER_T sController[CTL_SIZE] =
{
   {-1,-1,0,0,0,0,0,0,0,{0,0,0,0},{0,0,0,0},{-1,-1,-1,-1},{0,0,0,0}}
};
#else
CONTROLLER_T sController[CTL_SIZE] =
{
   {-1,-1,0,0,0,0,0,0,0,{0,0,0,0},{0,0,0,0},{-1,-1,-1,-1},{0,0,0,0}},
   {-1,-1,0,0,0,0,0,0,0,{0,0,0,0},{0,0,0,0},{-1,-1,-1,-1},{0,0,0,0}},
   {-1,-1,0,0,0,0,0,0,0,{0,0,0,0},{0,0,0,0},{-1,-1,-1,-1},{0,0,0,0}},
   {-1,-1,0,0,0,0,0,0,0,{0,0,0,0},{0,0,0,0},{-1,-1,-1,-1},{0,0,0,0}}
};
#endif

/* AIOP type structures */
AIOP_T sAiopTypes[AIOPID_0001 + 1] =
{
   {
      MasterMCode1,MCODE1_SIZE   /* unused member */
   },
   {
      MasterMCode1,MCODE1_SIZE   /* AIOP release 1 */
   },
};

/* IRQ number to MUDBAC register 2 mapping */
unsigned char sIRQMap[16] =
{
   0,0,0,0x10,0x20,0x30,0,0,0,0x40,0x50,0x60,0x70,0,0,0x80
};

/* Device map table.  Use to convert a controller number, AIOP number, and
   channel number into a device number. */
#ifdef INT14DRV
int sDevMapTbl[CTL_SIZE][AIOP_CTL_SIZE][CHAN_AIOP_SIZE] =
{
   {
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV}
   }
};
#else
int sDevMapTbl[CTL_SIZE][AIOP_CTL_SIZE][CHAN_AIOP_SIZE] =
{
   {
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV}
   },
   {
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV}
   },
   {
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV}
   },
   {
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV},
      {NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV,NULLDEV}
   }
};
#endif

/* Bit map to low conversion table.  "Low" is the bit position of the
   lowest order bit set in the bit map. -1 indicates no bits are set. */
int sBitMapToLowTbl[256] =
{
   -1,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,
   4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0
};

unsigned char sBitMapClrTbl[8] =
{
   0xfe,0xfd,0xfb,0xf7,0xef,0xdf,0xbf,0x7f
};

unsigned char sBitMapSetTbl[8] =
{
   0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80
};

#endif /* #ifndef GLOBALDEFINED */

